<?php
/*
  $Id: cm_sc_related_products.php
  $Loc: catalog/includes/modules/content/shopping_cart/

  Related Products 7.1
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2019: Rainer Schmied - @raiwa

  All rights reserved.﻿﻿

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

  class cm_sc_related_products {
    var $code;
    var $group;
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->code = get_class($this);
      $this->group = basename(dirname(__FILE__));

      $this->title = MODULE_CONTENT_SC_RELATED_PRODUCTS_TITLE;
      $this->description = MODULE_CONTENT_SC_RELATED_PRODUCTS_DESCRIPTION;
      $this->description .= '<p>by @raiwa <u><a target="_blank" href="http://www.oscaddons.com">www.oscaddons.com</a></u></p>';
      $this->description .= '<div class="secWarning">
                              <a target="_blank" href="http://www.oscaddons.com/en/commercial-add-ons/related-products-pro-p-43.html">GET RELATED PRODUCTS PRO<br>
                                - Category selection menus added in Admin Page<br>
                                - Added optional display of Product Id, Name, Model in Admin Page<br>
                                - Sort order options added for Admin Page<br>
                              </a>
                            </div>';

      if ( defined('MODULE_CONTENT_SC_RELATED_PRODUCTS_STATUS') ) {
        $this->sort_order = MODULE_CONTENT_SC_RELATED_PRODUCTS_SORT_ORDER;
        $this->enabled = (MODULE_CONTENT_SC_RELATED_PRODUCTS_STATUS == 'True');
      }
    }

    function execute() {
      global $oscTemplate, $languages_id, $currencies, $currency, $PHP_SELF;

      $content_width = MODULE_CONTENT_SC_RELATED_PRODUCTS_CONTENT_WIDTH;
      $card_layout = IS_PRODUCT_PRODUCTS_LAYOUT;
      $ids_in_cart_list = $this->products_in_cart();

      $orderBy = 'order by ';
      $orderBy .= (MODULE_CONTENT_SC_RELATED_PRODUCTS_RANDOMIZE == 'True')?'rand()':'pop_order_id, pop_id';
      $orderBy .= (MODULE_CONTENT_SC_RELATED_PRODUCTS_MAX_DISP > 0)?' limit ' . MODULE_CONTENT_SC_RELATED_PRODUCTS_MAX_DISP:'';

      $optional_rel_prods = "select distinct p.products_id, p.products_image, pd.products_name, products_tax_class_id, products_price, IF(s.status, s.specials_new_products_price, NULL) as specials_new_products_price, if(s.status, s.specials_new_products_price, p.products_price) as final_price, p.products_quantity as in_stock, if(s.status, 1, 0) as is_special, p.manufacturers_id, prp.pop_products_id_slave";

      if (MODULE_CONTENT_SC_RELATED_PRODUCTS_SHOW_DESCRIPTION == 'True')
        $optional_rel_prods .= ", substring_index(pd.products_description, ' ', " . MODULE_CONTENT_SC_RELATED_PRODUCTS_DESCRIPTION_LENGTH . ") as products_description";

      $optional_rel_prods .= " from
                              products_related_products prp,
                              products p
                              left join products_description pd on pd.products_id = p.products_id
                              left join specials s on s.products_id = p.products_id 
                              where prp.pop_products_id_slave = p.products_id
                              and pd.products_id = p.products_id
                              and language_id = '" . (int)$languages_id . "'
                              and pop_products_id_master in (" . $ids_in_cart_list . ")
                              and products_status='1' " . $orderBy;

      $optional_rel_prods_query = tep_db_query($optional_rel_prods);

      $num_products = tep_db_num_rows($optional_rel_prods_query);

      if ($num_products > 0) {

        ob_start();
        include('includes/modules/content/' . $this->group . '/templates/tpl_' . basename(__FILE__));
        $template = ob_get_clean();

        $oscTemplate->addContent($template, $this->group);
      }
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_CONTENT_SC_RELATED_PRODUCTS_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Current Version', 'MODULE_CONTENT_SC_RELATED_PRODUCTS_VERSION_INSTALLED', '7.1', 'Read only.', '6', '1', 'tep_version_readonly(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Related Products Module', 'MODULE_CONTENT_SC_RELATED_PRODUCTS_STATUS', 'True', 'Should the optional_related_products block be shown on the shopping cart page?', '6', '2', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Width', 'MODULE_CONTENT_SC_RELATED_PRODUCTS_CONTENT_WIDTH', '12', 'What width container should the content be shown in?', '6', '4', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_CONTENT_SC_RELATED_PRODUCTS_SORT_ORDER', '1100', 'Sort order of display. Lowest is displayed first.', '6', '6', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Display Product Description', 'MODULE_CONTENT_SC_RELATED_PRODUCTS_SHOW_DESCRIPTION', 'False', 'Show Product Description', '6', '9', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Maximum Description length', 'MODULE_CONTENT_SC_RELATED_PRODUCTS_DESCRIPTION_LENGTH', '25', 'The number of words of the Description to display.', '6', '1', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Define Number of Items to Display', 'MODULE_CONTENT_SC_RELATED_PRODUCTS_MAX_DISP', '12', 'Maximum number of Related Products to display. 0 is unlimited.', '6', '12', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Use Random Display Order', 'MODULE_CONTENT_SC_RELATED_PRODUCTS_RANDOMIZE', 'False', 'Adds random sort order to products displayed. Recommended if maximum number of products is set.', '6', '17', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
    }

    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_CONTENT_SC_RELATED_PRODUCTS_VERSION_INSTALLED', 
                   'MODULE_CONTENT_SC_RELATED_PRODUCTS_STATUS', 
                   'MODULE_CONTENT_SC_RELATED_PRODUCTS_SORT_ORDER', 
                   'MODULE_CONTENT_SC_RELATED_PRODUCTS_CONTENT_WIDTH', 
                   'MODULE_CONTENT_SC_RELATED_PRODUCTS_SHOW_DESCRIPTION', 
                   'MODULE_CONTENT_SC_RELATED_PRODUCTS_DESCRIPTION_LENGTH',
                   'MODULE_CONTENT_SC_RELATED_PRODUCTS_MAX_DISP', 
                   'MODULE_CONTENT_SC_RELATED_PRODUCTS_RANDOMIZE');
    }

    // courtesy x-sell by @kymation
    protected function products_in_cart() {
      global $cart;

      // Get a list of the products in the cart from the cart class
      $ids_in_cart = $cart->get_product_id_list();

      // Convert the comma separated list to an array
      $ids_in_cart_array_1 = explode( ',', $ids_in_cart );

      // Remove whitespace from the array values
      $ids_in_cart_array_2 = array_map( 'trim', $ids_in_cart_array_1 );

      // Convert values to integers to get rid of options/attributes
      $ids_in_cart_array = array_map( 'intval', $ids_in_cart_array_2 );

      // Convert array to coma separated string list for sql query
      $ids_in_cart_list = implode( ',', $ids_in_cart_array );

      return $ids_in_cart_list;
    }

  }  // End class

// function show the version read only
  if(!function_exists('tep_version_readonly')) {
    function tep_version_readonly($value){
      $version_text = '<br>Version ' . $value;
      return $version_text;
    }
  }
